#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

typedef long long ll;

vector<int> rand_set(int n, int k)
{
    vector<int> ans;
    for (int i = 0; i < k; i++)
        ans.push_back(rnd.next(n - k + 1));
    sort(ans.begin(), ans.end());
    for (int i = 0; i < k; i++)
        ans[i] += i;
    return ans;
}

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int c = atoi(argv[2]);
    int t = atoi(argv[3]);
    ll k = atoll(argv[4]);
    int trash_k = atoi(argv[5]);
    vector<int> trash = rand_set(n, trash_k);
    vector<bool> used(n, false);
    for (int i : trash)
        used[i] = true;
    cout << n << " " << c << "\n";
    for (int i = 0; i < n; i++)
    {
        cout << t << " ";
        if (used[i])
            cout << rnd.next(1LL, (ll)(1e18)) << "\n";
        else
            cout << k << "\n";
    }
    return 0;
}