#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

typedef long long ll;

int solve(int n, int c, vector<pair<ll, ll>> v)
{
    sort(v.rbegin(), v.rend());
    set<pair<ll, int>> q;
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        q.insert(make_pair(v[i].second, i));
        ll cur = v[i].first - (i + 1 == n ? 0LL : v[i + 1].first);
        cur *= c;
        while (cur > 0 && !q.empty())
        {
            if (q.begin()->first <= cur)
            {
                cur -= q.begin()->first;
                ans++;
                q.erase(q.begin());
            }
            else
            {
                pair<ll, int> t = *q.begin();
                q.erase(t);
                q.insert(make_pair(t.first - cur, t.second));
                cur = 0;
            }
        }
    }
    return ans;
}

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int t = atoi(argv[2]);
    ll up_k = atoll(argv[3]);
    int ans = atoi(argv[4]);
    int type = atoi(argv[5]);
    vector<pair<ll, ll>> v;
    for (int i = 0; i < n; i++)
        v.push_back(make_pair(t, rnd.next(up_k) + 1));
    int l = 1;
    int r = (int)(1e9) + 1;
    if (type != 1)
        r = (int)(1e9);
    while (r - l > 1)
    {
        int h = (l + r) >> 1;
        if (type == 1)
        {
            if (solve(n, h, v) <= ans)
                l = h;
            else
                r = h;
        }
        else
        {
            if (solve(n, h, v) < ans)
                l = h;
            else
                r = h;
        }
    }
    if (type == 1)
        cout << n << " " << l << "\n";
    else
        cout << n << " " << r << "\n";
    for (pair<ll, ll> t : v)
        cout << t.first << " " << t.second << "\n";
    return 0;
}