#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

typedef long long ll;

void validateTest(int maxn, int maxc, int maxt, ll maxk, bool is_equal)
{
    int n = inf.readInt(1, maxn, "n");
    inf.readSpace();
    int c = inf.readInt(1, maxc, "c");
    inf.readEoln();
    int last_t;
    for (int i = 0; i < n; i++)
    {
        int t = inf.readInt(1, maxt, format("t[%d]", i + 1));
        inf.readSpace();
        ll k = inf.readLong(1LL, maxk, format("k[%d]", i + 1));
        inf.readEoln();
        if (i > 0)
            ensuref(!is_equal || last_t == t, "all values of t should be equal");
        last_t = t;
    }
    inf.readEof();
}

int main(int argc, char** argv)
{
    registerValidation(argc, argv);

    if (validator.group() == "1")
        validateTest(1, (int)(1e9), (int)(1e9), (ll)(1e18), false);
    else if (validator.group() == "2")
        validateTest(16, (int)(1e9), (int)(1e9), (ll)(1e18), false);
    else if (validator.group() == "3")
        validateTest(2000, 1, 2000, (ll)(1e18), false);
    else if (validator.group() == "4")
        validateTest(2000, (int)(1e9), (int)(1e9), (ll)(1e18), false);
    else if (validator.group() == "5")
        validateTest(200 * 1000, (int)(1e9), (int)(1e9), (ll)(1e18), true);
    else
        validateTest(200 * 1000, (int)(1e9), (int)(1e9), (ll)(1e18), false);

    return 0;
}