// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <bits/stdc++.h>
 
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
 
typedef long long ll;
typedef long double ld;
 
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
 
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
const int N = 200100;
 
class Item {
public:
    ll t, k;
 
    Item() = default;
 
    Item(ll t, ll k) : t(t), k(k) {}
 
    bool operator<(const Item& other) const {
        return t < other.t;
    }
};
 
Item a[N];
 
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
 
    int n;
    ll c;
    scanf("%d%lld", &n, &c);
 
    for (int i = 0; i < n; ++i) {
        scanf("%lld%lld", &a[i].t, &a[i].k);
    }
 
    int ans = 0;
    std::vector<int> res;
    for (int mask = 0; mask < (1 << n); ++mask) {
        std::vector<Item> cur;
        int curAns = 0;
 
        for (int i = 0; i < n; ++i) {
            if (((mask >> i) & 1) == 1) {
                cur.push_back(a[i]);
                ++curAns;
            }
        }
 
        std::sort(cur.begin(), cur.end());
 
        ll curDay = 0;
        for (int i = 0; i < (int)cur.size(); ++i) {
            ll days = cur[i].t - curDay;
 
            if (days * c < cur[i].k) {
                curAns = 0;
                break;
            }
 
            ll needDays = cur[i].k / c;
            curDay += needDays;
 
            if (cur[i].k % c != 0) {
                ++curDay;
 
                if (i != (int)cur.size() - 1) {
                    cur[i + 1].k -= c - cur[i].k % c;
                    cur[i + 1].k = std::max(cur[i + 1].k, 0ll);
                }
            }
        }
 
        ans = std::max(ans, curAns);
        if (ans == curAns && ans != 0) {
            res.clear();
 
            for (int i = 0; i < n; ++i) {
                if (((mask >> i) & 1) == 1) {
                    res.push_back(i);
                }
            }
        }
    }
 
    printf("%d\n", ans);
    for (auto i : res) {
        printf("%d ", i + 1);
    }
    printf("\n");
 
    return 0;
}