// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <bits/stdc++.h>
 
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
 
typedef long long ll;
typedef long double ld;
 
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
 
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
const int N = 200100;
 
int n;
ll c;
ll t[N], k[N];
  
class Item {
public:
    ll days, rest;
    ll timing;
    int id;
  
    Item() = default;
  
    Item(ll days, ll rest, ll timing, int id) : days(days), rest(rest), timing(timing), id(id) {}
  
    bool operator<(const Item& other) const {
    	ll curT = days - timing;
    	ll otherT = other.days - other.timing;

    	return curT < otherT || (curT == otherT && timing < other.timing) || (curT == otherT && rest < other.rest && timing == other.timing)
    						 || (curT == otherT && rest == other.rest && timing == other.timing && id < other.id);
        // return days < other.days || (days == other.days && rest < other.rest)
        //                          || (days == other.days && rest == other.rest && timing < other.timing)
        //                          || (days == other.days && rest == other.rest && timing == other.timing && id < other.id);
    }
};
 
class Item1 {
public:
    ll t, k;
  
    Item1() = default;
  
    Item1(ll t, ll k) : t(t), k(k) {}
  
    bool operator<(const Item1& other) const {
        return t < other.t;
    }
};
  
Item1 a[N];
 
std::vector<int> bad() {
    for (int i = 0; i < n; ++i) {
        a[i].k = k[i];
        a[i].t = t[i];
    }
 
    int ans = 0;
    std::vector<int> res;
    for (int mask = 0; mask < (1 << n); ++mask) {
        std::vector<Item1> cur;
        int curAns = 0;
  
        for (int i = 0; i < n; ++i) {
            if (((mask >> i) & 1) == 1) {
                cur.push_back(a[i]);
                ++curAns;
            }
        }
  
        std::sort(cur.begin(), cur.end());
  
        ll curDay = 0;
        for (int i = 0; i < (int)cur.size(); ++i) {
            ll days = cur[i].t - curDay;
  
            if (days * c < cur[i].k) {
                curAns = 0;
                break;
            }
  
            ll needDays = cur[i].k / c;
            curDay += needDays;
  
            if (cur[i].k % c != 0) {
                ++curDay;
  
                if (i != (int)cur.size() - 1) {
                    cur[i + 1].k -= c - cur[i].k % c;
                    cur[i + 1].k = std::max(cur[i + 1].k, 0ll);
                }
            }
        }
  
        ans = std::max(ans, curAns);
        if (ans == curAns && ans != 0) {
            res.clear();
  
            for (int i = 0; i < n; ++i) {
                if (((mask >> i) & 1) == 1) {
                    res.push_back(i);
                }
            }
        }
    }
  
    return res;
}
 
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
 
    scanf("%d%lld", &n, &c);
  
    for (int i = 0; i < n; ++i) {
        scanf("%lld%lld", &t[i], &k[i]);
    }
 
    if (n <= 16) {
        auto res = bad();
 
        printf("%d\n", (int)res.size());
        for (auto i : res) {
            printf("%d ", i + 1);
        }
        printf("\n");
         
        return 0;
    }
 
    std::set<Item> setik;
    for (int i = 0; i < n; ++i) {
        setik.insert(Item((k[i] + c - 1) / c, k[i] % c, t[i], i));
    }
  
    ll curDay = 1;
    ll delta = 0;
    std::vector<int> ans;
    while (!setik.empty()) {
        // ll needDays = setik.begin()->days;
        // if (setik.begin()->rest != 0) {
        //  ++needDays;
        // }
  
        ll needDays = 1;
        ll curK = k[setik.begin()->id];
        curK = std::max(0ll, curK - (c - delta));
  
        needDays += curK / c;
        curK %= c;
  
        if (curK % c != 0) {
            ++needDays;
        }
  
        // debug(setik.begin()->id + 1);
        // debug(curDay);
        // debug(needDays);
  
        if (curDay + needDays - 1 > setik.begin()->timing) {
            setik.erase(setik.begin());
            continue;
        }
  
        // debug(setik.begin()->id);
        ans.push_back(setik.begin()->id);
        // TODO: recalc delta
  
        if (needDays == 1) {
            ll sh = k[setik.begin()->id];
            if (sh == c - delta) {
                delta = 0;
            } else {
                delta += sh;
            }
            // delta = 
        } else {
            delta = curK;
        }
        if (delta == 0) {
            curDay += needDays;
        } else {
            curDay += needDays - 1;
        }
        // debug(curDay);
        // debug(delta);
        // debug(setik.begin()->id);
  
        setik.erase(setik.begin());
    }
  
    printf("%d\n", (int)ans.size());
    for (auto i : ans) {
        printf("%d ", i + 1);
    }
    printf("\n");
 
    return 0;
}