#include <bits/stdc++.h>

using namespace std;

using i32 = int32_t;
using i64 = int64_t;

int main() {
#ifdef GOLIKOV
  freopen("in", "rt", stdin);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n;
  i64 c;
  cin >> n >> c;
  struct item {
    i64 t;
    i64 k;
    int i;

    bool operator<(item const& other) const {
      return tie(k, i) < tie(other.k, other.i);
    }
  };
  vector<item> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i].t >> a[i].k;
    a[i].i = i;
  }
  sort(a.begin(), a.end(), [](auto const& x, auto const& y) {
    return x.t > y.t;
  });
  set<item> alive;
  vector<int> answer;
  for (int i = 0; i < n; ++i) {
    auto can = c * (a[i].t - (i + 1 == n ? 0 : a[i + 1].t));
    alive.insert(a[i]);
    while (can && !alive.empty()) {
      auto x = *alive.begin();
      alive.erase(alive.begin());
      auto eat = min(x.k, can);
      can -= eat;
      x.k -= eat;
      if (x.k) {
        alive.insert(x);
      } else {
        answer.push_back(x.i);
      }
    }
  }
  cout << answer.size() << '\n';
  for (auto i : answer) {
    cout << i + 1 << ' ';
  }
  cout << '\n';
  return 0;
}
