#include "testlib.h"
#include <vector>

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int a = atoi(argv[1]), b = atoi(argv[2]), c = atoi(argv[3]);
    int x = atoi(argv[4]), y = atoi(argv[5]), z = atoi(argv[6]);

    vector<pair<int, int>> rects{
            {a, x},
            {b, y},
            {c, z}
    };
    shuffle(rects.begin(), rects.end());

    for (auto const &r : rects) {
        if (rnd.next(2)) {
            cout << r.first << '\n' << r.second << '\n';
        } else {
            cout << r.second << '\n' << r.first << '\n';
        }
    }
}