// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <bits/stdc++.h>
 
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
 
typedef long long ll;
typedef long double ld;
 
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
 
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
 
int a[3], b[3];
int p[3] = {0, 1, 2};
 
ll solve() {
    int a0 = a[p[0]];
    int a1 = a[p[1]];
    int a2 = a[p[2]];
 
    int b0 = b[p[0]];
    int b1 = b[p[1]];
    int b2 = b[p[2]];
 
    ll s1 = 1ll * std::max({a0, a1, a2}) * (b0 + b1 + b2);
    ll s2 = 1ll * std::max(a0, a1 + a2) * (b0 + std::max(b1, b2));
    ll s3 = 1ll * std::max(a0 + a2, a1) * std::max(b0 + b1, b2);
 
    return std::min({s1, s2, s3});
}
 
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
 
    for (int i = 0; i < 3; ++i) {
        scanf("%d%d", &a[i], &b[i]);
    }
 
    ll ans = (ll)1e18;
 
    do {
        for (int i = 0; i < 2; ++i) {
            for (int j = 0; j < 2; ++j) {
                for (int k = 0; k < 2; ++k) {
                    ans = std::min(ans, solve());
                    std::swap(a[2], b[2]);
                }
                std::swap(a[1], b[1]);
            }
            std::swap(a[0], b[0]);
        }
    } while (std::next_permutation(p, p + 3));
 
    printf("%lld\n", ans);
 
    return 0;
}