//  Copyright 2019 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using i32 = int32_t;
using i64 = int64_t;

int main() {
#ifdef GOLIKOV
  freopen("in", "rt", stdin);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  vector<pair<i64, i64>> rects(3);
  for (auto& r : rects) {
    cin >> r.first >> r.second;
  }
  i64 answer = numeric_limits<i64>::max();
  auto update = [&](i64 x, i64 y) {
    auto res = x * y;
    if (res < answer) {
      answer = res;
    }
  };
  vector<int> p(3);
  iota(p.begin(), p.end(), 0);
  do {
    for (unsigned m = 0; m < (1u << 3u); ++m) {
      vector<i64> xs(3), ys(3);
      for (unsigned i = 0; i < 3; ++i) {
        xs[i] = rects[p[i]].first;
        ys[i] = rects[p[i]].second;
        if ((m >> i) & 1u) {
          swap(xs[i], ys[i]);
        }
      }
      i64 x = max(xs[0], xs[1] + xs[2]);
      i64 y = ys[0] + max(ys[1], ys[2]);
      update(x, y);
      x = *max_element(xs.begin(), xs.end());
      y = accumulate(ys.begin(), ys.end(), 0ll);
      update(x, y);
    }
  } while (next_permutation(p.begin(), p.end()));
  cout << answer << '\n';
  return 0;
}
