#include "testlib.h"

const int MAXX[] = {
        1'000'000'000,      // sample
        20,                 // 1
        500,                // 2
        2000,               // 3
        100'000,            // 4
        1'000'000'000,      // 5
};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    auto gr = validator.group().empty() ? 0 : validator.group()[0] - '0';

    int l1 = inf.readInt(1, MAXX[gr], "l1");
    inf.readEoln();
    int r1 = inf.readInt(l1, MAXX[gr], "r1");
    inf.readEoln();
    int l2 = inf.readInt(r1 + 1, MAXX[gr], "l2");
    inf.readEoln();
    int r2 = inf.readInt(l2, MAXX[gr], "r2");
    inf.readEoln();

    inf.readEof();

    return 0;
}
