#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 4);
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	int maxp = atoi(argv[3]);

	vector<vector<int>> graph(n);
	cout << n << " " << m << "\n";
	for (int i = 1; i < n; ++i) {
		while (true) {
			int p = rnd.next(0, i - 1);
			if (szof(graph[p]) + (p > 0) == maxp) {
				continue;
			}
			graph[p].push_back(i);
			cout << p + 1 << " " << i + 1 << "\n";

			break;
		}
	}

	for (int i = 0; i < n; ++i) {
		shuffle(graph[i].begin(), graph[i].end());
	}

	vector<int> order;

	function<void(int)> dfs = [&](int v) {
		order.push_back(v);
		for (int to : graph[v]) {
			dfs(to);
		}
	};

	dfs(0);

	for (int i = 0; i < m; ++i) {
		while (true) {
			int a = rnd.next(0, n - 1);
			int b = rnd.next(0, n - 1);
			if (a >= b) {
				continue;
			}

			cout << order[a] + 1 << " " << order[b] + 1 << "\n";
			break;
		}
	}

	return 0;
}