#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> graph(n);
	for (int i = 1; i < n; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	function<void(int, int)> dfs0 = [&](int v, int p) {
		if (v) {
			graph[v].erase(find(graph[v].begin(), graph[v].end(), p));
		}
		for (int to : graph[v]) {
			dfs0(to, v);
		}
	};

	dfs0(0, 0);

	vector<vector<int>> here(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		here[b].push_back(a);
	}

	int ans = 0;
	vector<int> used(n);

	vector<vector<int>> orders(n);
	for (int i = 0; i < n; ++i) {
		orders[i] = vector<int>(szof(graph[i]));
		iota(orders[i].begin(), orders[i].end(), 0);
	}

	function<int(int)> dfs = [&](int v) {
		for (int from : here[v]) {
			if (!used[from]) {
				return 0;
			}
		}
		used[v] = true;
		for (int ind : orders[v]) {
			int to = graph[v][ind];
			if (!dfs(to)) {
				return 0;
			}
		}
		return 1;
	};

	while (true) {
		// for (int i = 0; i < n; ++i) {
		// 	for (int ind : orders[i]) {
		// 		cerr << graph[i][ind] + 1 << " ";
		// 	}
		// 	cerr << endl;
		// }
		fill(used.begin(), used.end(), 0);
		int tmp = dfs(0);
		// if (tmp) {
		// 	cerr << "+" << endl;
		// }
		ans += tmp;
		bool flag = false;
		for (int i = n - 1; i >= 0; --i) {
			if (next_permutation(orders[i].begin(), orders[i].end())) {
				flag = true;
				break;
			}
		}
		if (!flag) {
			break;
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
