#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

typedef long long ll;

int n;
ll c;
vector<ll> t, k;

int readAns(InStream& stream)
{
    int s = stream.readInt(0, n, "[number of products]");
    vector<int> used(n, -1);
    for (int i = 0; i < s; i++)
    {
        int p = stream.readInt(1, n, format("[id of product #%d in the answer]", i + 1)) - 1;
        if (used[p] != -1)
        {
            string verd = format("product #%d used twice in the answer", p + 1) +
                          format(" (%d", used[p] + 1) + englishEnding(used[p] + 1) + " and " +
                          format("%d", i + 1) + englishEnding(i + 1) + ")";
            stream.quitf(_wa, verd.c_str());
        }
        used[p] = i;
    }
    vector<pair<ll, ll>> v;
    for (int i = 0; i < n; i++)
        if (used[i] != -1)
            v.push_back(make_pair(t[i], k[i]));
    sort(v.rbegin(), v.rend());
    ll up = v[0].first * c;
    ll sum = 0;
    for (pair<ll, ll> t : v)
    {
        sum += t.second;
        if (sum > up)
            stream.quitf(_wa, "it is impossible to eat all products from the given set");
    }
    ll ost = 0;
    for (int i = 0; i < (int)v.size(); i++)
    {
        ost += v[i].second;
        ll cur = v[i].first - (i + 1 == (int)v.size() ? 0 : v[i + 1].first);
        ost = max(0LL, ost - c * cur);
    }
    if (ost != 0)
        stream.quitf(_wa, "it is impossible to eat all products from the given set");
    return s;
}

void readinput()
{
    n = inf.readInt();
    c = inf.readLong();
    t.resize(n);
    k.resize(n);
    for (int i = 0; i < n; i++)
    {
        t[i] = inf.readLong();
        k[i] = inf.readLong();
    }
}

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);

    readinput();

    int jans = readAns(ans);
    int pans = readAns(ouf);

    if (pans == jans)
        quitf(_ok, "jury and participant found equal answers: ans = %d", jans);
    else if (jans > pans)
        quitf(_wa, "jury found better answer: jans=%d > pans=%d", jans, pans);
    else
        quitf(_fail, "participant found better answer: pans=%d > jans=%d", pans, jans);

    return 0;
}