#include <bits/stdc++.h>

using namespace std;

using i32 = int32_t;
using i64 = int64_t;

int main() {
#ifdef GOLIKOV
  freopen("in", "rt", stdin);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n;
  i64 c;
  cin >> n >> c;
  struct item {
    i64 t;
    i64 k;
    int i;
  };
  vector<item> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i].t >> a[i].k;
    a[i].i = i;
  }
  sort(a.begin(), a.end(), [](auto const& x, auto const& y) {
    return x.t < y.t || x.t == y.t && x.k < y.k;
  });
  i64 const INF = numeric_limits<i64>::max();
  vector<vector<i64>> dp(n + 1, vector<i64>(n + 1, INF));
  vector<vector<bool>> p(n + 1, vector<bool>(n + 1));
  dp[0][0] = 0;
  for (int i = 0; i < n; ++i) {
    dp[i + 1][0] = 0;
    auto add = a[i].k;
    auto bound = a[i].t * c;
    for (int len = 0; len <= i; ++len) {
      dp[i + 1][len + 1] = dp[i][len + 1];
      auto sum = dp[i][len];
      if (sum == INF) {
        continue;
      }
      if (sum + add <= bound) {
        if (sum + add < dp[i + 1][len + 1]) {
          dp[i + 1][len + 1] = sum + add;
          p[i + 1][len + 1] = true;
        }
      }
    }
  }
  int l = -1;
  for (int i = n; i >= 0; --i) {
    if (dp[n][i] != INF) {
      l = i;
      break;
    }
  }
  cout << l << '\n';
  for (int it = n; l; --it) {
    if (p[it][l]) {
      cout << a[it - 1].i + 1 << ' ';
      --l;
    }
  }
  cout << '\n';
  return 0;
}