#include<bits/stdc++.h>

using namespace std;

struct Item {
    long long t;
    long long cnt;
    int id;

    bool operator<(const Item &rhs) const {
        return tie(cnt, t, id) < tie(rhs.cnt, rhs.t, rhs.id);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef HOME
    freopen("in.txt", "r", stdin);
#endif
    int n;
    long long c;
    cin >> n >> c;
    vector<Item> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].t >> a[i].cnt;
        a[i].id = i;
    }
    bool allTEqual = true;
    for (int i = 1; i < n; i++) {
        if (a[i].t != a[0].t) {
            allTEqual = false;
        }
    }
    sort(a.begin(), a.end());
    if (allTEqual) {
        long long have = 0;
        long long time = 0;
        vector<Item> ans;
        for (auto &x : a) {
            have += c * (x.t - time);
            time = x.t;
            if (have < x.cnt) {
                break;
            }
            ans.push_back(x);
            have -= x.cnt;
        }
        cout << ans.size() << endl;
        for (auto &x : ans) {
            cout << x.id + 1 << ' ';
        }
        return 0;
    }
    vector<Item> ans;
    auto ok = [&](vector<Item> items) {
        sort(items.begin(), items.end(), [](const Item &a, const Item &b) {
            return a.t < b.t;
        });
        long long have = 0;
        long long time = 0;
        for (auto &x : items) {
            have += c * (x.t - time);
            time = x.t;
            if (have < x.cnt) {
                return false;
            }
            have -= x.cnt;
        }
        return true;
    };
    for (auto &i : a) {
        auto newAns = ans;
        newAns.push_back(i);
        if (ok(newAns)) {
            ans = newAns;
        }
    }
    cout << ans.size() << endl;
    for (auto &x : ans) {
        cout << x.id + 1 << ' ';
    }
}