#ifdef LOCAL
#include "../../testlib.h"
#else
#include "testlib.h"
#endif

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int a = atoi(argv[1]), x = atoi(argv[2]), alpha = atoi(argv[3]), beta = atoi(argv[4]);
    int m = alpha * a, b1 = rnd.next(1, m - 1), b2 = m - b1;
    int n1 = beta * a;
    vector<pair<int, int>> sizes{
        {n1, b1},
        {n1, b2},
        {alpha * x, n1},
        {n1 + beta * x, m},
    };
    shuffle(sizes.begin(), sizes.end());

    for (int i = 0; i < 4; i++) {
        if (rnd.next(2)) {
            printf("%d %d\n", sizes[i].first, sizes[i].second);
        } else {
            printf("%d %d\n", sizes[i].second, sizes[i].first);
        }
    }

}
