// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"

typedef long long ll;
typedef long double ld;

std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;

int main(void) {
	// #ifdef ONLINE_JUDGE
	// 	freopen(NAME".in", "r", stdin);
	// 	freopen(NAME".out", "w", stdout);
	// #endif

	int a, b, c, d;
	scanf("%d%d%d%d", &a, &b, &c, &d);

	ll ans = 0;

	for (int len1 = b - a + 1; len1 >= 1; --len1) {
		int l = a, r = b - len1 + 1;

		int delta = (b - a + 1) - len1;
		int len2 = (d - c + 1) + delta;

		int L = d - len2 + 1;
		int R = c;

		if (L > b) {
			ans += 1ll * (R - L + 1) * (r - l + 1);
		} else {
			ans += 1ll * (R - (b + 1) + 1) * (r - l + 1);

			int last = (R - L + 1) - (R - (b + 1) + 1);
			ans += (1ll * (2ll * (r - l) - (last - 1)) * last) / 2ll;
		}
	}

	printf("%lld\n", ans);

	return 0;
}
