///created by Arsenii Kirillov
#ifdef DEBUG
# define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int) (x).size())

template <typename T>
T input() {
    T res;
    std::cin >> res;
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()


using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 123;
const ll INFL = 1e18 + 1e6;
mt19937 tw(228);
ll rnd(ll l, ll r) { return tw() % (r - l + 1) + l; }

const int mod = (int)1e9 + 7;

int add(int a, int b)
{
	return a + b >= mod ? a + b - mod : a + b;
}

int sub(int a, int b)
{
	return a < b ? a + mod - b : a - b;
}

int mul(int a, int b)
{
	return ((long long)a * b) % mod;
}

int used[(int)1e5 + 10], tin[(int)1e5 + 10], tout[(int)1e5 + 10], up[(int)1e5 + 10];
vector<int> mas[(int)1e5 + 10], child[(int)1e5 + 10];
vector<int> arr[(int)1e5 + 10][15];
int tim = 0;

void dfs(int v)
{
	tin[v] = tim++;
	used[v] = 1;
	for (int u: mas[v])
	{
		if (used[u] == 0)
		{
			child[v].push_back(u);
			up[u] = v;
			dfs(u);
		}
	}
	tout[v] = tim++;
}

int cnt(int v, int m)
{
	vector<int> dp(1 << m, 0);
	dp[0] = 1;
	for (int mask = 0; mask < (1 << m); mask++)
	{
		for (int i = 0; i < m; i++)
		{
			if ((mask & (1 << i)) == 0)
			{
				bool d = 1;
				for (int j: arr[v][i])
				{
					if (mask & (1 << j))
					{
						d = 0;
						break;
					}
				}
				if (d)
					dp[mask + (1 << i)] = add(dp[mask + (1 << i)], dp[mask]);
			}
		}
	}
	return dp[(1 << m) - 1];
}

void get(int a, int b)
{
	if (tin[b] < tin[a] && tout[a] < tout[b])
	{
		cout << 0 << endl;
		exit(0);
	}
	if (tin[a] < tin[b] && tout[b] < tout[a])
		return;
	int cur = a, aa = a;
	while (tout[cur] < tin[b] || tout[b] < tin[cur])
	{
		aa = cur;
		cur = up[cur];
	}
	int bb = b;
	while (up[bb] != cur)
		bb = up[bb];
	for (int i = 0; i < (int)child[cur].size(); i++)
	{
		if (child[cur][i] == aa)
		{
			aa = i;
			break;
		}
	}
	for (int i = 0; i < (int)child[cur].size(); i++)
	{
		if (child[cur][i] == bb)
		{
			bb = i;
			break;
		}
	}
	arr[cur][aa].push_back(bb);
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n - 1; i++)
	{
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		mas[a].push_back(b);
		mas[b].push_back(a);
	}	
	dfs(0);
	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		get(a, b);
	}
	int ans = 1;
	for (int i = 0; i < n; i++)
	{
		m = child[i].size();
		fill(used, used + m, 0);
		ans = mul(ans, cnt(i, m));
	}
	cout << ans << endl;
}

int main() {
    cout << fixed << setprecision(15);
    cerr << fixed << setprecision(15);
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int t = 1;
    // cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }

#ifdef LOCAL
    cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
    return 0;
}